<?php

 if ( ! defined('ABSPATH') ) {
    exit; // Exit if accessed directly
 }

/**
 * Faspay Debit Plugin Installation process
 *
 * This file is used for creating tables while installing the plugins.
 *
 * Copyright (c) faspay
 *
 * This script is only free to the use for merchants of faspay. If
 * you have found this script useful a small recommendation as well as a
 * comment on merchant form would be greatly appreciated.
 *
 * @package     Faspay
 * @author      Periyanto
 *
 */

 /**
  * Creates Faspay tables while activating the plugins
  * Calls from the hook "register_activation_hook"
  *
  * @param none
  * @return void
  */

 function faspay_activation_process(){

        //GetTheTableNameWithTheWPdatabasePrefix
        global $wpdb;
        $table_name = $wpdb->prefix . "faspay_order";
            
        global $divebook_db_table_dive_version;
        $installed_ver = get_option( "divebook_db_table_dive_version" );

            //Check if the table already exists and if the table is up to date, if not create it
            if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name ||  $installed_ver != $divebook_db_table_dive_version ) {
                $sql = "CREATE TABLE " . $table_name . " (
                    trx_id bigint(10) NOT NULL,
                    order_id varchar(30) NOT NULL,
                    date_trx datetime NOT NULL,
                    date_payment datetime NOT NULL,
                    total_amount varchar(30) NOT NULL,
                    payment_reff varchar(30) NOT NULL,
                    channel varchar(30) NOT NULL,
                    status varchar(30) NOT NULL,
                    UNIQUE KEY trx_id (trx_id)
                    );";
                
                require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
                dbDelta($sql);
                update_option( "divebook_db_table_dive_version", $divebook_db_table_dive_version );
            }
        
        //AddDatabaseTableVersionsToOptions
        add_option("divebook_db_table_dive_version", $divebook_db_table_dive_version);
        
}
 

 /**
  * Deletes the faspay configuration values from wp_options tables
  * Calls from the hook "register_deactivation_hook"
  *
  * @param none
  * @return void
  */
 function faspay_uninstallation_process() {
    global $wpdb;
    $wpdb->query("delete from $wpdb->options where option_name like '%faspay%'");
 }
?>
